import { Lang } from "@/constants/languages"
import { batchRequest } from "@/lib/graphql/batchRequest"
import {
  EntryByUrlBatch1,
  EntryByUrlBatch2,
} from "@/lib/graphql/Query/ResolveEntry.graphql"
import { internalServerError } from "@/server/errors/next"

import { validateEntryResolveSchema } from "@/types/requests/entry"

export async function resolve(url: string, lang = Lang.en) {
  const variables = { locale: lang, url: url || "/" }

  // The maximum amount of content types you can query is 6, therefor more
  // than that is being batched
  const cacheKey = `${lang}:${url}:resolveentry`
  const response = await batchRequest([
    {
      document: EntryByUrlBatch1,
      variables,
      cacheOptions: {
        ttl: "max",
        key: cacheKey,
      },
    },
    {
      document: EntryByUrlBatch2,
      variables,
      cacheOptions: {
        ttl: "max",
        key: cacheKey,
      },
    },
  ])

  const validatedData = validateEntryResolveSchema.safeParse(response.data)

  if (!validatedData.success) {
    throw internalServerError(validatedData.error)
  }

  for (const value of Object.values(validatedData.data)) {
    if (value.total) {
      const { content_type_uid, uid } = value.items[0].system
      return {
        contentType: content_type_uid,
        uid,
      }
    }
  }

  return {
    contentType: null,
    uid: null,
  }
}
